using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace BreadAndCheese {
    /// <summary>
    /// To jest główny typ Twojej gry.
    /// </summary>
    public class BreadAndCheeseGame : Microsoft.Xna.Framework.Game {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        // Świat gry
        Texture2D cheeseTexture;
        Rectangle cheeseRectangle;
        float cheeseX;
        float cheeseXSpeed;
        float cheeseY;
        float cheeseYSpeed;
        float cheeseWidthFactor = 0.05f;
        float cheeseTicksToCrossScreen = 200.0f;

        // Ustawienia ekranu
        float displayWidth;
        float displayHeight;
        float overScanPercentage = 10.0f;
        float minDisplayX;
        float maxDisplayX;
        float minDisplayY;
        float maxDisplayY;

        float getPercentage(float percentage, float inputValue) {
            return (inputValue * percentage) / 100;
        }

        private void setupScreen() {
            displayWidth = graphics.GraphicsDevice.Viewport.Width;
            displayHeight = graphics.GraphicsDevice.Viewport.Height;
            float xOverscanMargin =
                    getPercentage(overScanPercentage, displayWidth) / 2.0f;
            float yOverscanMargin =
                    getPercentage(overScanPercentage, displayHeight) / 2.0f;

            minDisplayX = xOverscanMargin;
            minDisplayY = yOverscanMargin;

            maxDisplayX = displayWidth - xOverscanMargin;
            maxDisplayY = displayHeight - yOverscanMargin;
        }

        void scaleSprites() {
            cheeseRectangle.Width = (int) ((displayWidth * cheeseWidthFactor) + 0.5f);
            float aspectRatio = (float) cheeseTexture.Width / cheeseTexture.Height;
            cheeseRectangle.Height = (int) ((cheeseRectangle.Width / aspectRatio) + 0.5f);
            cheeseX = minDisplayX;
            cheeseY = minDisplayY;
            cheeseXSpeed = displayWidth / cheeseTicksToCrossScreen;
            cheeseYSpeed = cheeseXSpeed;
        }

        public BreadAndCheeseGame() {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Umożliwia ewentualną inicjalizację przed uruchomieniem właściwej gry.
        /// W tym miejscu można odnaleźć wszystkie wymagane zasoby i załadować treści
        /// related content. Wywołanie metody base.Initialize spowoduje przeszukanie wszystkich komponentów
        /// i ich inicjalizację.
        /// </summary>
        protected override void Initialize() {
            setupScreen();

            base.Initialize();
        }

        /// <summary>
        /// Metoda LoadContent jest wywoływana tylko raz dla całej gry i jako taka jest właściwym miejscem
        /// dla kodu ładującego treść.
        /// </summary>
        protected override void LoadContent() {
            // Tworzy nowy obiekt klasy SpriteBatch, którego można używać do rysowania tekstur.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            cheeseTexture = Content.Load<Texture2D > ("Images/Cheese");

            scaleSprites();

        }

        /// <summary>
        /// Metoda UnloadContent jest wywoływana tylko raz dla całej gry i jako taka jest właściwym miejscem
        /// dla kodu usuwającego całą treść z pamięci.
        /// </summary>
        protected override void UnloadContent() {
            // TODO: Należy usunąć całą treść, którą nie zarządza ContentManager.
        }

        /// <summary>
        /// Umożliwia grze wykonywanie logiki związanej z aktualizacją świata gry,
        /// sprawdzaniem kolizji, pobieraniem danych wejściowych czy odtwarzaniem dźwięków.
        /// </summary>
        /// <param name="gameTime">Udostępnia wartości reprezentujące bieżący czas.</param>
        protected override void Update(GameTime gameTime) {
            // Pozwala opuścić grę
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            cheeseX = cheeseX + cheeseXSpeed;
            cheeseY = cheeseY + cheeseYSpeed;
            cheeseRectangle.X = (int) (cheeseX + 0.5f);
            cheeseRectangle.Y = (int) (cheeseY + 0.5f);

            if (cheeseX + cheeseRectangle.Width >= maxDisplayX) {
                cheeseXSpeed = cheeseXSpeed * -1;
            }

            if (cheeseX <= minDisplayX) {
                cheeseXSpeed = cheeseXSpeed * -1;
            }

            if (cheeseY + cheeseRectangle.Height >= maxDisplayY) {
                cheeseYSpeed = cheeseYSpeed * -1;
            }

            if (cheeseY <= minDisplayY) {
                cheeseYSpeed = cheeseYSpeed * -1;
            }

            base.Update(gameTime);
        }

        /// <summary>
        /// Ta metoda jest wywoływana w momencie, w którym gra musi narysować swój świat.
        /// </summary>
        /// <param name="gameTime">Udostępnia wartości reprezentujące bieżący czas.</param>
        protected override void Draw(GameTime gameTime) {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();

            spriteBatch.Draw(cheeseTexture, cheeseRectangle, Color.White);

            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
